
#define OPTIMIZE_ROM_CALLS

/*#define DrawStr 1
#define Rect 2
#define FillRect 3
#define Sprite 4
#define Line 5
#define Effect_T 6
#define Italic_T 7
#define Font 8
#define Set_Pix 9
#define Get_Pix 10
#define Wait_Key 11
#define KBHit 12
#define StrWidth 13
#define Wait 14
#define Clr_Scr 15
#define SL_Msg 16
#define No_Break 17
#define Idle 19
#define SprBlur 20
#define WK_NoBrk 21
#define SetTimer 22
#define GetTimer 23
#define GetImage 24
#define Map 26
#define Key_Init 27
#define Key_Delay 28
#define Apd 29
#define Ellipse 30
#define FillTri 31
#define RowRead 32
#define AllocScr 33
#define RclScr 34
#define FreeScr 35
#define FindErr 36
#define Dialog 37
#define Reset 666
#define Version 999*/

#define bas 99
#define droit 159

#include <tigcclib.h>

SCR_RECT full_screen;


void push_str(const char *str)	{
		char tmpstr[100];
		short x;
		strcpy(tmpstr+1,str);
		tmpstr[0]=34;
		x=strlen(tmpstr);
		tmpstr[x]=34;
		tmpstr[x+1]=0;
		push_parse_text(tmpstr);
}

void BrunniIDLE(short temps)	{			// :-)
   OSFreeTimer(1);
   OSRegisterTimer(1,temps);
	 while (!OSTimerExpired(1) && !kbhit()) idle();
}

short Temp = 0, Num = 0 ;
char *Retour = NULL ;
//SCR_RECT fullscr;

/////////////////////////////////////////////////////////////////////////////////////////
//	Ajoute  'retour' la chane pointe par 'str' en respectant les conventions du TIOS,
//	'retour' sera ensuite stock dans 'fl'.
//
//	Adds to 'retour' the string pointed by 'str', respecting the TIOS conventions, 
//	'retour' will be copied in 'fl' at the end.
/////////////////////////////////////////////////////////////////////////////////////////

unsigned short var_len(char *var)
{
	return (2+*(unsigned short*)var) ;
}

char *mk_nam(char *str)
{
	static char name[19] = {0} ;
	short len = strlen(str) ;
	
	if (len > 17) return NULL ;
	
	return strcpy(name+1, str)+len ;
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Renvoie un SYM_ENTRY vers la variable locale de nom format 'nom'.
//
//	Returns a SYM_ENTRY pointing to the local variable named 'nom'.
/////////////////////////////////////////////////////////////////////////////////////////

SYM_ENTRY *get_temp_entry(char *nom)
{
	SYM_ENTRY *entry = DerefSym(FindSymInFolder(nom, TempFolderName(Temp))) ;
	
	while (*(--nom) != 0 && *nom != 92) ;
	return (entry != NULL && *nom != 92 ? entry : NULL) ;
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Renvoie un SYM_ENTRY vers la variable dont le nom est stock dans 'str'.
//
//	Returns a SYM_ENTRY pointing to the symbol whose name is stocked in 'str'.
/////////////////////////////////////////////////////////////////////////////////////////

char *get_ptr(SYM_ENTRY *entry)
{
	if (entry == NULL || entry->handle == H_NULL) return NULL ;
	return (char*)HeapDeref(entry->handle) ;
}

SYM_ENTRY *get_entry(char *str)
{
	char *nom = mk_nam(str) ;
	SYM_ENTRY *entry = get_temp_entry(nom) ;
	
	if (entry != NULL) return entry ;
	return SymFindPtr(nom, 0) ;
}


void bitmap_put(short x, short y, unsigned char *pic, short option)
{
	if (*(pic+256**pic+*(pic+1)+1) == 0xDF && x<240 && y<127)
			WinBitmapPut(DeskTop, x, y, pic+2, option) ;
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Vrifie que la variable pointe par 'entry' est bien dsarchive.
//
//	Checks that the variable pointed by 'entry' is unarchived.
/////////////////////////////////////////////////////////////////////////////////////////

short check(char *str)
{
	SYM_ENTRY *entry = get_entry(str) ;
	
	if (entry != NULL && entry->flags.bits.archived != 0)
	{
		return EM_moveSymFromExtMem(mk_nam(str), HS_NULL) ;
	}
	return 1 ;
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Cre un pointeur vers une variable dont le nom est stock dans 'str', 
//	et alloue  la variable une place en mmoire 'taille'.
//
//	Creates a pointer to a variable whose name is stocked in 'str', 
//	and allocates for the variable a place 'taille' bytes long in memory.
/////////////////////////////////////////////////////////////////////////////////////////

char *mk_ptr(char *str, unsigned short taille)
{
	char *nom = mk_nam(str) ;
	SYM_ENTRY *entry = get_temp_entry(nom) ;

	if (check(str) == 0) return NULL ;

	entry = DerefSym(entry != NULL ? AddSymToFolder(nom, TempFolderName(Temp)) : SymAdd(nom)) ;
	if (entry == NULL) return NULL ;

	nom = (char*)HeapDeref(entry->handle = HeapAlloc(taille)) ;
	if (entry->handle == H_NULL) return NULL ;

	*(unsigned short*)nom = taille-2 ;

	return (nom+2) ;
}

