// C Header File
// Created 21/11/02; 21:55:01

#define _rom_call(type,args,ind) (*(type(**)args)(*(long*)0xC8+0x##ind*4))
#define ScrRectFill  _rom_call(void,(SCR_RECT*,SCR_RECT*,short),189)
#define DrawClipRect _rom_call(void,(WIN_RECT*,SCR_RECT*,short),195)
#define TIOSDrawLine _rom_call(void,(short,short,short,short,short),1A7)
#define DrawStr      _rom_call(void,(short,short,char*,short),1A9)
#define DrawChar     _rom_call(void,(short,short,char,short),1A4)
#define FontGetSys   _rom_call(unsigned char,(void),18E)
#define FontSetSys   _rom_call(unsigned char,(short),18F)
#define DrawStrWidth _rom_call(short,(char*,short),197)
#define PortSet      _rom_call(void,(void*,short,short),1A2)
#define malloc       _rom_call(void*,(long),A2)
#define free         _rom_call(void,(void*),A3)
#define memset       _rom_call(void*,(void*,short,long),27C)
#define memcpy       _rom_call(void*,(void*,const void*,long),26A)
#define FULLSCREEN  &(SCR_RECT){{0, 0, 239, 127}}

#define CALCULATOR (ROM_base==(void*)0x400000)
#define ROM_base ((void*)((*(unsigned long*)0xC8)&0x600000))
#define LCD_WIDTH (CALCULATOR?240:160)
#define LCD_HEIGHT (CALCULATOR?128:100)
#define LCD_SIZE 3840

