// C Source File
// Created 31.03.02; 12:58:31

#define RETURN_VALUE cr

#define USE_TI89          // Produce .9xz File
#define USE_TI92PLUS          // Produce .9xz File
//#define USE_TI92PLUS

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define NO_EXIT_SUPPORT

#include <tigcclib.h>         // Include All Header Files
#include "commun.h"

/* Ma lib
Vous pouvez faire plusieurs fonctions dans le mme appel de clib. Exemple:
clib(8,2,oo,7,0,10,4,"Rien"), ceci executera la fonction 8 qui prendra l'argument
2, puis le sigle infini indiquera qu'on passe  la prochaine fonction, puis la
fonction 7 qui prendra (et qui demande) les 4 prochains arguments.
Sinon, ma lib est optimise au niveau vitesse. Le fait d'assembler les arguments
vous en fera gagner (y compris la taille du code sera rduite).
Fonction 01: Ecrit du texte; clib(1,x,y,mode,"Texte")
Fonction 02: Dessine un rectangle; clib(2,x0,y0,x1,y1,mode)
Fonction 03: Rectangle plein; clib(3,x0,y0,x1,y1,mode)
Fonction 04: Dessine un sprite; clib(4,x,y,mode,"image")
Fonction 05: Dessine une ligne; clib(5,x0,y0,x1,y1,mode)
Fonction 06: Dessine du texte en gras; clib(6,x,y,mode,type_de_gras,"Texte")
Fonction 07: Dessine le texte en italique; clib(7,x,y,mode,"Texte")
Fonction 08: Rgle la fonte courante; clib(8,fonte)
Fonction 09: Dessine un pixel; clib(9,x,y,mode)
Fonction 10: Renvoie dans cr l'tat d'un pixel; clib(10,x,y)
Fonction 11: Attend l'appui d'une touche puis en renvoie la valeur; clib(11)
Fonction 12: Renvoie la valeur de la touche appuye mais n'attend pas et ne vide pas le tampon; clib(12)
Fonction 13: Renvoie la taille de la chaine en pixels; clib(13,fonte,"chaine")
Fonction 14: Attend un moment; clib(14,100)
Fonction 15: Efface l'cran; clib(15)
Fonciton 16: Affiche un message dans la StatusLine; clib(16,"slmsg")
Fonction 17: Dsactive le break; clib(17)
Fonction 18: Aggrandit un objet; clib(18,x0,y0,x1,y1,factx,facty,reapparx,reappary)
Fonction 19: Attend en IDLE (1/20 de seconde): cl(19,temps)
Fonction 20: Affiche une image et la blure (filtre): cl(20,x,y,mode,"image"). Attend une touche mais ne vide pas le tampon!
Fonction 21: Attend une touche et enlve le break si ON a t press; cl(21)
Fonction 22: Rgle le timer interne (1/20 sec.); cl(22,temps) (compte  rebours)
Fonction 23: Retourne la valeur du timer; cl(23)
Fonction 24: Sauve une partie d'cran comme image; cl(24,x0,y0,x1,y1,"variable")		->MERCI FL!!!
Fonction 25: Rgle la fonte (non-proportionnelle et compatible avec FLIB); cl(25,fonte)
Fonction 26: Affiche une map  partir d'une matrice "mat"; cl(26,x,y,dbutMatX,dbutMatY,FinMatX,FinMatY,TailleImageX,TailleImageY,"ImageBase","mat")
En fait, cela rajoute la valeur de chaque lment de la matrice comme caractre  "ImageBase" et affiche l'image correspondante.
Ex: Si mat[1,1]=49 et ImageBase="pic" -> char(49)="1" -> Image="pic1" -> Affichage pic1!
Note: Si "mat" est omis, la matrice MAT sera prise par dfaut.
Fonction 27: Rgle le dlai des touches, le temps avant que la rptition se mette en marche; cl(27,temps)
Fonction 28: Rgle le dlai entre chaque rptition de touches (une fois enclenche); cl(28,temps)
*/

void _main(void)
{
	char virtual[LCD_SIZE];  // Allocate the buffer
//	TRY
	int argtype, cmd, affscr=1;
	int a,b,d,n,t=0,u=0,x=0,y=0;
	unsigned char *na;
	//Les arguments par dfaut s'ils sont omis...
	long args[12]={0,0,0,4,1,1,7,1,1,4};
	//args[1]=0; args[2]=0; args[3]=4; args[4]=1; args[5]=2; args[6]=2; args[7]=0; args[8];
	char * str="", * mat="mat";
	unsigned char * nam, *nam2, scrtemp=0;
	short i;
	static unsigned char erase[] = {
  0b0,
  0b0,
  0b0,
  0b0,
  0b0,
  0b0};
	static unsigned char sabl[] = {
  0b111100,
  0b100100,
  0b011000,
  0b011000,
  0b100100,
  0b111100};
	full_screen=(SCR_RECT){{0,0,droit,bas}};
	unsigned long int wait;
	unsigned long int w;
	char buf[105];
  ESI argptr=top_estack;
  SCR_RECT text_size;
  char buffer [LCD_SIZE+4];
    
	push_quantum(END_TAG);  	//Je bricole l, ceci indique seulement la fin de la liste (et le dbut de la nouvelle qui sera renvoye donc)
 	while (GetArgType(argptr)!=END_TAG)	{
	reev:

	if (GetArgType(argptr)==31)
			cmd = GetIntArg (argptr);
	else {
			SkipArg(argptr);
			goto reev;
	}

 	n=1;
  
	do		{
  		argtype=GetArgType(argptr);
			if (argtype==32 || argtype==31)	{
			  args[n++] = GetIntArg (argptr);
			  if (argtype==32) args[n-1]=-args[n-1];
			}
			else break;
	}  while(n<12);
	
  if(argtype==STR_TAG)
  str = GetStrnArg(argptr);
  if(GetArgType(argptr)==STR_TAG)
  mat = GetStrnArg(argptr);
  
  DeskTop->Clip.xy.y0 = 0;
	DeskTop->Clip.xy.y1 = bas;
		
	rearg:

	if (cmd==1 || cmd==6)	{
			if (DeskTop->CurFont!=FontGetSys())		WinFont(DeskTop,1);
			if (args[1]==999)		args[1]=80-DrawStrWidth(str,FontGetSys())/2;
	}
	if (cmd==9) WinAttr(DeskTop,args[3]);
	
  if ( cmd == 1 || cmd==6)	{
	  WinAttr(DeskTop,args[3]);
  	WinStrXY ( DeskTop, args[1],args[2],str);
		  }
  if ( cmd == 2 || cmd==3 || cmd==5)	{
   	 WinAttr(DeskTop,args[5]);
 		 WIN_RECT rect={args[1], args[2], args[3], args[4]};
 		 SCR_RECT zone={{args[1], args[2], args[3], args[4]}};
 		 if (cmd==2)	WinRect (DeskTop, &rect, args[5]);
		 else if (cmd==3) ScrRectFill (&zone, &full_screen, args[5]);
		 else  WinLine (DeskTop, &rect);
  }
  if (cmd==11 || cmd==21 || cmd==14 || cmd==19 || cmd==41)	{
//  	if (!GetPix(158,98))
//  		Sprite8(156, 94, 6, erase, LCD_MEM, SPRT_AND);
  	if (scrtemp)
  		LCD_restore (virtual);
  }
  if ( cmd == 4)
  		bitmap_put(args[1],args[2],get_ptr(get_entry(str)),args[3]);
  if (args[2]>=0 && args[1]>=-1 && args[1]<=droit && args[2]<=bas)	{
  if ( cmd == 6)	{
  a = DrawStrWidth ( str, FontGetSys() );
  text_size = (SCR_RECT){{args[1]+1, args[2], args[1]+a, args[2]+5+ 2*FontGetSys()}};
  BitmapGet (&text_size, buffer);
  b=args[4]%4;
  if ( b == 1 )	{
  if ( args[3] )
  BitmapPut (args[1]+2, args[2], buffer, &full_screen, A_NORMAL);
  else
  BitmapPut (args[1]+2, args[2], buffer, &full_screen, 6);
  }
  if ( b == 2 )	{
  if ( args[3] )
  BitmapPut (args[1]+1, args[2]+1, buffer, &full_screen, A_NORMAL);
  else
  BitmapPut (args[1]+1, args[2]+1, buffer, &full_screen, 6);
  }
  if ( b == 3 )	{
  if ( args[3] )
  BitmapPut (args[1]+2, args[2]+1, buffer, &full_screen, A_NORMAL);
  else
  BitmapPut (args[1]+2, args[2]+1, buffer, &full_screen, 6);
  }
	if (args[4]>=4)	{		//Aussi en italique...
  text_size = (SCR_RECT){{args[1]+1,args[2], args[1]+a, args[2] + ((5+ 2*FontGetSys())/2)}};
  BitmapGet (&text_size, buffer);
 	ScrRectFill(&text_size,&text_size,args[3]==0);
  BitmapPut (args[1]+2, args[2], buffer, &full_screen, A_REPLACE);
	}
  }
	}
	if ( cmd == 7 )	{
	cmd=6;			//Pour la compatibilit
	args[4]=4;
	goto rearg;
	}
  if ( cmd == 8 )	{
  WinFont ( DeskTop,args[1] );
  }
  if ( cmd == 9 )	{
  WinPixSet (DeskTop,args[1], args[2]);
  }
  if ( cmd == 10 )	{
  push_longint( GetPix (args[1],args[2]));
  }
  if ( cmd == 11 || cmd==21 )	{
  while (!kbhit()) BrunniIDLE(1);
  push_getkey();
  if (cmd==21) OSClearBreak();
  }
  if ( cmd == 12 )	{
	  a=kbhit();
	  push_getkey();
	  if (a)
		pushkey(a);
	}
  if ( cmd == 13 )	{
  push_longint( DrawStrWidth (str, args[1]));
  }
  if ( cmd == 14 && args[1]>=0)	{
  w = args[1]*1000;
  for ( wait = 0 ; wait < w ; wait -- ) wait+=2;
  }
  if ( cmd == 15 )
  	ScrRectFill(&full_screen,&full_screen,args[1]);
  if ( cmd == 16 )	{
  ST_showHelp (str);
  }
  if ( cmd == 17 )	{
  OSDisableBreak();
  OSClearBreak();
 	}
  /*if ( cmd == 18 )	{
	t=args[3]-args[1]+1;
  u=args[4]-args[2]+1;
  char m[u][t];
  for (y=args[2];y<=args[4];y++)	{
  for (x=args[1];x<=args[3];x++)	m[y-args[2]][x-args[1]]=GetPix(x,y);	}
  for (y=0;y<=u-1;y++)	{
  for (x=0;x<=t-1;x++)	{
  Fillrect = (SCR_RECT){{args[7]+args[5]*x,args[8]+args[6]*y,args[7]+args[5]*x+args[5]-1,args[8]+args[6]*y+args[6]-1}};
  ScrRectFill (&Fillrect, &full_screen, m[y][x]);
  }
  }
  }
		Deux algorithmes d'agrandissement conus par moi (mais trop lents)
if ( cmd == 18 )	{
	t=args[3]-args[1];
  u=args[4]-args[2];
  char m[u+1][t+1];
	for (p=args[2];p<=args[4];p++)	{
		for (q=args[1];q<=args[3];q++)	{
	 		m[p-args[2]][q-args[1]]=GetPix(q,p);
  	}
  }
  for (p=args[8];p<=args[8]+args[6];p++)	{
	  for (q=args[7];q<=args[7]+args[5];q++)	{
  		DrawPix(q,p,m[(p-args[8])*u/args[6]][(q-args[7])*t/args[5]]);
  	}
 	}
}	*/
   if ( cmd == 19 )	{
			BrunniIDLE(args[1]);
  }
  
  if ( cmd == 20 )	{
  str=get_ptr(get_entry(str));
	while (!kbhit())	{
	bitmap_put(args[1],args[2],str,args[3]);
	BrunniIDLE(1);
	bitmap_put(args[1]+1,args[2],str,args[3]);
	BrunniIDLE(1);
	}
	}

	if (cmd==22)	{
	OSFreeTimer(args[1]);
	OSRegisterTimer(args[1],args[2]);
	}
	if (cmd==23)	{
	if (!OSTimerExpired(args[1]))
	push_longint(OSTimerCurVal(args[1]));
	else push_longint(0);
	}
	if (cmd==24 && args[1]>=0 && args[2]>=0 )	{
	if (n<=3) {
		args[3]=LCD_WIDTH-1; args[4]=LCD_HEIGHT-1;
	}
				if (args[1] <= args[3] && args[2] <= args[4])
			{
				text_size = (SCR_RECT){{args[1],args[2],args[3],args[4]}} ;
				a = BitmapSize(&text_size) ;
				nam = mk_ptr(str, a+3) ;
				if (nam != NULL)
				{
					BitmapGet(&text_size, nam) ;
					nam[a] = 0xDF ;
				}
			}
		}

	if (cmd == 26)	{
			while (args[3]<1)	{
				args[3]++;
				args[1]+=args[7];
			}
			while (args[4]<1)	{
				args[4]++;
				args[2]+=args[8];
			}
		
				x=args[1];
				y=args[2];
				w=strlen(str)-1;

			d=*(str+w)-1;
				
			SYM_ENTRY *entry = get_entry(mat) ;
			if (entry != NULL)	{
			nam=get_ptr(entry);
			nam2=nam+3;
			nam+=var_len(nam)-5;
			for (a=1;a<args[4];a++)	{
				while (*nam!=31)	nam-=3;
				nam-=2;
			}
		
			for (b=args[4];b<=args[6];b++)	{
			nam=nam-3*args[3]+3;
			for (a=args[3];a<=args[5] && *nam!=31;a++)	{
			if (nam<=nam2) goto fin;
			*(str+w)=(*nam)+d;
			bitmap_put(x,y,get_ptr(get_entry(str)),args[9]);
			nam-=3;
			x+=args[7];  //args[7];
			}
				while (*nam!=31)	{
				nam-=3;
				}
				nam-=2;
				x=args[1];
				y+=args[8];	}
			}
	}
	fin:

	if (cmd==27) OSInitKeyInitDelay(args[1]);
	if (cmd==28) OSInitBetweenKeyDelay(args[1]);
	if (cmd==29) 	{
	OSFreeTimer(2) ;
	OSRegisterTimer(2, 20*args[1]) ;
	}
	if (cmd==30)	{
	WinAttr(DeskTop,args[5]);
	WinEllipse (DeskTop, args[1], args[2], args[3], args[4]);
	}
	if (cmd==31)	{
	WinFillTriangle (DeskTop, args[1], args[2], args[3], args[4], args[5], args[6], args[7]);
	}
	if (cmd==32)	{		//RowRead
				i = _rowread(0xfffe) ;
			#ifdef USE_TI89
				push_longint(i&16);
				push_longint(i&32);
				push_longint(i&64);
				push_longint(i&128);
				push_longint(i&2);
				push_longint(i&8);
				push_longint(i&1);
				push_longint(i&4);
			#else
				push_longint(i&1);
				push_longint(i&4);
				push_longint(i&2);
				push_longint(i&8);
				push_longint(i&16);
				push_longint(i&64);
				push_longint(i&32);
				push_longint(i&128);
			#endif
}
	if (cmd==33)	{
		scrtemp=1;
		if (args[1]==0)
			memcpy(virtual,LCD_MEM,LCD_SIZE);
		else affscr=0;
		PortSet (virtual, 239, 127); // Et hop! Tout revient sur le ScrTemp (virtual)
	}
	if (cmd==34 || cmd==35)	{
	LCD_restore (virtual);		//Affiche le contenu du ScrTemp
	if (cmd==35)	{
	PortRestore();		//Libre l'cran
	scrtemp=0;
	}}
	if (cmd==36)	{
	if (strlen(find_error_message(args[1]))>=100) goto exi;
		strcpy(buf,find_error_message(args[1]));
			for (a=0;a<(signed)strlen(buf);a++)	
				if (buf[a]==34)
					buf[a]=39;
		push_str(buf);		//Ajoute la chane d'erreur args[1]
	}
	exi:
	
	if (cmd==37)	{
		for (a=0;a<(signed)strlen(mat);a++)
			if (mat[a]==13) mat[a]=10;
		push_longint(DlgMessage(str,mat,args[1],args[2]));		//Dialogue
	}
	if (cmd==39) args[1]=0xB2;
	
	if (cmd==38 || cmd==39)	pokeIO(0x600017,args[1]);		//Notre timer est personnalisable... (AUTO_INT_5)

	if (cmd==40)	{
	short z=0;
	char car, car2;
	#define z2 u
	#define x2 n
	
	y=args[2];
	t=strlen(str);
	while (y<args[4])	{
	x=args[1];
	if (str[z]==32) z++;
	while (1)	{
	if (z>t)
	goto fin2;
	
	car2=str[z++];
	if (car2==32 && args[6]==1)	{
	x2=x;
	z2=z;
	do	{
	car=str[z2++];
	x2+=FontCharWidth(car);
	if (x2>args[3]) goto fin1;
	if (car==13) break;
	if (car==32 || car==0) break;
	}	while(1);
	}
	if (x+FontCharWidth(car2)>args[3]) {
		z--;
		break;
	}
	if (!car2) goto fin2;
	if (car2!=13)
	DrawClipChar(x,y,car2,&full_screen,args[5]);
	else break;

	x+=FontCharWidth(car2);

	}
	fin1:
	y+=6+2*FontGetSys();
	}
	fin2:
	push_longint(x);
	push_longint(y);
	push_longint(z);

	}
	
	if (cmd==41)	{
			na = get_ptr(get_entry(str)) ;
			nam = na+var_len(na)-2 ;
			if (na != NULL)	{
					if (*(nam+1) == OTH_TAG)
					{
						while (*(--nam) != 0) ;
						push_str(nam+1) ;
					}
					else
						push_longint(*(nam+1));
			}
	}
	
	if (cmd==42)
	  ST_busy(args[1]);
	
	if (cmd==666)
		OSReset();		//Hh!
	if (cmd==999) {
		push_str ("CLIB par Brnni! f.bron@isuisse.com #");		//La fonction push_str est complique  faire!
		push_parse_text ("expr(\"2.10\")");
	}
	}
  
  if (scrtemp && affscr)	{
  LCD_restore (virtual);
	PortRestore();
  }

//	if (!GetPix(158,98))
//	Sprite8 (154, 94, 6, sabl, LCD_MEM, SPRT_OR);
  if (GetArgType(top_estack)==END_TAG)
  push_longint(0);
//  ONERR
//  ENDTRY
  push_quantum(LIST_TAG);
}
